<?PHP
/**************************** php ipblocker ****************************
*                     http://phpipblocker.evcz.tk                      *
*                             version 0.99c                            *
*                                                                      *
*     developed by EvolutionCrazy (AKA evcz) for B.I.S.S. forum ;)     *
*                             evcz@evcz.tk                             *
*                                                                      *
*    Script distributed under GNU/GPL license (version 2 or higher)    *
*                                                                      *
*                   comments and suggestions here:                     *
*       http://www.bluetack.co.uk/forums/index.php?showforum=156       *
*                                                                      *
***********************************************************************/

//control if the script is already installed
if(file_exists("INSTALL.LOCK")){
	die("<b>php ipblocker</b> is already installed, to re-install/upgrade it you need to deleted the file <b>maintain/INSTALL.LOCK</b>");
	exit();
}

require_once("functions.php");
require_once("config.php");

if(!is_dir($ipblocker['fullpathLogName'])){
	$oldumask = umask(0);
	mkdir($ipblocker['fullpathLogName'], $ipblocker['fullpathLogName_chmod']);
	umask($oldumask);
	echo "<b>1</b>- Logging directory <i>".$ipblocker['fullpathLogName']."</i> successfully created and chmodded to <i>".decoct($ipblocker['fullpathLogName_chmod'])."</i><br />";
}
else
	echo "<b>1</b>- Logging directory <i>".$ipblocker['fullpathLogName']."</i> already exists... make sure it's correctly chmodded ;)<br />";

//mysql connection + db creation
if($ipblocker['persistent'])
	$ipblocker_connection = @mysql_pconnect($ipblocker['db_server'], $ipblocker['db_user'], $ipblocker['db_pass']) or die(mysql_error());
else
	$ipblocker_connection = @mysql_connect($ipblocker['db_server'], $ipblocker['db_user'], $ipblocker['db_pass']) or die(mysql_error());

//create database if not exists
mysql_query("CREATE DATABASE IF NOT EXISTS `".$ipblocker['db_name']."`", $ipblocker_connection) or die(mysql_error());

//select the database
mysql_select_db($ipblocker['db_name'], $ipblocker_connection) or die(mysql_error());

echo "<b>2</b>- Database <i>".$ipblocker['db_name']."</i> successfully selected<br />";

//delete old table if exists
mysql_query("DROP TABLE IF EXISTS `".$ipblocker['db_table_name']."`", $ipblocker_connection) or die(mysql_error());

//create the new table
mysql_query("CREATE TABLE `ipblocker` ( `start` int(10) unsigned NOT NULL default '0', `end` int(10) unsigned NOT NULL default '0', `rangename` varchar(64) NOT NULL default '', KEY `multi_sx` (`start`,`end`), KEY `multi_dx` (`end`,`start`), KEY `start` (`start`), KEY `end` (`end`)) TYPE=MyISAM;", $ipblocker_connection) or die(mysql_error());

echo "<b>3</b>- Table <i>".$ipblocker['db_table_name']."</i> successfully created<br />";

//fill the table with the blocklists
$stats = fillTable();

//close connection to mysql server
ipblocker_disconnect();

//update the lastrun date (fakecron)
if($ipblocker['fakecron_enabled']){
	$fp = fopen ('update.lastrun.php', 'wb') or die("Error opening the update.lastrun.php file! cannot proceed... chmod it corretly (generally 775 or higher)");
	fwrite ($fp, "<"."?php $"."lastrun = ".time()."; ?".">") or die("Error writing the update.lastrun.php file! cannot proceed... chmod it corretly (generally 775 or higher)");
	fclose ($fp) or die("Error closing the update.lastrun.php file! cannot proceed... chmod it corretly (generally 777)");
	$oldumask = umask(0);
	chmod("update.lastrun.php", $ipblocker['fakecron_lastrun_chmod']);
	umask($oldumask);
}

//print messages
echo "<b>4</b>- Block lists loaded<br />
&nbsp;&nbsp;&nbsp;&nbsp;".$stats['lists_number']." lists processed<br />
&nbsp;&nbsp;&nbsp;&nbsp;".$stats['lists_skipped']." lists skipped (unsupported format)<br />
&nbsp;&nbsp;&nbsp;&nbsp;".$stats['rules_number']." blocked ranges processed<br />
&nbsp;&nbsp;&nbsp;&nbsp;".$stats['exclusions_rules_number']." granted ranges processed<br />
&nbsp;&nbsp;&nbsp;&nbsp;your ".$ipblocker['db_table_name']." table now contains ".$stats['sql_rows']." ranges<br />
&nbsp;&nbsp;&nbsp;&nbsp;process completed in ".$stats['time']." seconds<br /><br />";
echo "Installation Completed, now add the <b>require_once(\"/fullpathname/ban.php\")</b> command in the beginning of the pages you want to protect<br /><br />";
echo "<b>Read docs/auto_updater.txt for info on how to use the autoupdate system.</b><br /><br />";

//create the INSTALL.LOCK file to lock your install process
$lock = @fopen ("INSTALL.LOCK", "a");
@fclose($lock);

//delete install.php file if lock procedure fails
if (!file_exists("INSTALL.LOCK")){
	echo "Unable to lock install.php! ... i'll try to delete it...<br />";

	//delete install.php file
	unlink("install.php");
	if (file_exists("install.php"))
		echo "I wasn't able to delete the <b>install.php</b> file, <b>delete it manually<b><br />";
	else
		echo "The <b>install.php</b> file has been deleted<br />";
}
else
	echo "The <b>install.php</b> now is locked, to run it again you need to delete the lock file: <b>maintain/INSTALL.LOCK<b><br />";
	
//finished
echo "<br /><br /><center><b>Installation completed successfully</b></center><br />";

/**********************************************************************
* This script is free software; you can redistribute it and/or        *
* modify it under the terms of the GNU Lesser General Public          *
* License as published by the Free Software Foundation.               *
*                                                                     *
* This script is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of      *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   *
* Lesser General Public License for more details.                     *
*                                                                     *
* You should have received a copy of the GNU Lesser General Public    *
* License along with this script; if not, write to the                *
* Free Software Foundation, Inc.,                                     *
* 59 Temple Place, Suite 330,                                         *
* Boston, MA                                                          *
* 02111-1307                                                          *
* USA                                                                 *
*                                                                     *
* For further information, visit www.gnu.org                          *
**********************************************************************/

?>